
#define ENC_PORT_CS C
#define ENC_PIN_CS 9
#define DSELECT() 		pinSET(ENC_PORT_CS,ENC_PIN_CS)
#define SELECT() 		pinCLR(ENC_PORT_CS,ENC_PIN_CS)
#define enc28j60_release() 		pinSET(ENC_PORT_CS,ENC_PIN_CS)
#define enc28j60_select() 		pinCLR(ENC_PORT_CS,ENC_PIN_CS)

#define spiENCsend(x) 		txrxSPI(SPI3,x)
#define spiENCreceive(x) 	txrxSPI(SPI3,x)
#define spiENC				SPI3
#define spiENC SPI3

void spiENCinit(void){

	//++++++++ CS
	  /* Deselect : Chip Select high */
		init_gpio_out(ENC_PORT_CS,ENC_PIN_CS);
		pinSET(ENC_PORT_CS,ENC_PIN_CS);

	//++++++++ spi
	SPI_InitTypeDef SPI_InitStruct;
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3, ENABLE);
    SPI_I2S_DeInit(spiENC);

	SPI_StructInit(&SPI_InitStruct);
	SPI_InitStruct.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStruct.SPI_Mode = SPI_Mode_Master;
	SPI_InitStruct.SPI_DataSize = SPI_DataSize_8b;
	SPI_InitStruct.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;//32
	SPI_InitStruct.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStruct.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStruct.SPI_CPHA = SPI_CPHA_1Edge;
	SPI_InitStruct.SPI_NSS = SPI_NSS_Soft;
    SPI_InitStruct.SPI_CRCPolynomial = 7;


	SPI_Init(SPI3, &SPI_InitStruct);
    SPI_Cmd(spiENC, ENABLE);


  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable SCK, MOSI and MISO GPIO clocks */
 // RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

  /* Enable CS  GPIO clock */
 // RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);

	GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_SPI3);
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource11, GPIO_AF_SPI3);
	GPIO_PinAFConfig(GPIOC, GPIO_PinSource12, GPIO_AF_SPI3);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;

  /* SPI SCK pin configuration */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  /* SPI  MOSI pin configuration */
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_12;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  /* SPI MISO pin configuration */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  /* Configure GPIO PIN for Chip select */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);


  //cr1:...7lsb,spe,5br,4br,3br,2mst,1cpol,0cpha
  SPI3->CR1 &= ~(3<<0);//CPOL=0,cPHA=0


  SPI3->CR1 &= ~(7<<3);//br=0=>fast->SPI_BaudRatePrescaler_2
  SPI3->CR1 |= SPI_BaudRatePrescaler_2;//br=0=>fast
 }




//--------------------------------------------------------------
// sendet und empfngt ein Byte per SPI3 (im Full-Duplex-Mode)
// ChipSelect-Signal muss von rufender Funktion gemacht werden
//--------------------------------------------------------------
uint8_t rxSPI(SPI_TypeDef* SPIx,uint8_t wert){
  uint16_t ret_wert=0;
  // warte bis senden fertig
  while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);
  // byte senden
  SPI_I2S_SendData(SPIx, wert);
  // warte bis empfang fertig
  while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
  // Daten einlesen
  ret_wert=SPI_I2S_ReceiveData(SPIx);
  return(ret_wert);
}


uint8_t txSPI(SPI_TypeDef* SPIx,uint8_t wert){
  uint16_t ret_wert=0;
  // warte bis senden fertig
  while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_TXE) == RESET);
  // byte senden
  SPI_I2S_SendData(SPIx, wert);
  // warte bis empfang fertig
  while (SPI_I2S_GetFlagStatus(SPIx, SPI_I2S_FLAG_RXNE) == RESET);
  // Daten einlesen
  ret_wert=SPI_I2S_ReceiveData(SPIx);
  return(ret_wert);
}

